PLaSK library

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
plask::ExtrudedTriangularMesh3D::Element Struct Reference

Represent FEM-like element (right triangular prism) in ExtrudedTriangularMesh3D. More...

`#include <plask/mesh/extruded_triangular3d.hpp>`

Collaboration diagram for plask::ExtrudedTriangularMesh3D::Element:
[legend]

## Public Member Functions
| Element (const ExtrudedTriangularMesh3D &mesh, std::size_t longTranIndex, std::size_t vertIndex)
| Element (const ExtrudedTriangularMesh3D &mesh, std::size_t elementIndex)
std::size_t | getIndex () const
std::size_t | getBottomNodeIndex (std::size_t bottom_triangle_node_nr) const
| Get mesh index of vertex of the bottom triangle.
std::size_t | getTopNodeIndex (std::size_t top_triangle_node_nr) const
| Get mesh index of vertex of the top triangle.
Vec< 3, double > | getBottomNode (std::size_t bottom_triangle_node_nr) const
| Get coordinates of the bottom base (triangle) vertex.
Vec< 3, double > | getTopNode (std::size_t bottom_triangle_node_nr) const
| Get coordinates of the top base (triangle) vertex.
Vec< 3, double > | getMidpoint () const
double | getBaseArea () const
| Get area of the prism base (which is a triangle).
double | getHeight () const
| Get height of the prism base.
double | getArea () const
| Get volume of the prism represented by this element.
double | getVolume () const
bool | contains (Vec< 3, double > p) const
| Check if point `p` is included in `this` element.
Box3D | getBoundingBox () const
| Calculate minimal box which contains this element.

## Public Attributes
const ExtrudedTriangularMesh3D & | mesh
std::size_t | longTranIndex
std::size_t | vertIndex

## Detailed Description

Represent FEM-like element (right triangular prism) in ExtrudedTriangularMesh3D.

Definition at line 42 of file extruded_triangular3d.hpp.

## Constructor & Destructor Documentation

## ◆ Element() [1/2]

plask::ExtrudedTriangularMesh3D::Element::Element | ( | const ExtrudedTriangularMesh3D & | mesh,
|  | std::size_t | longTranIndex,
|  | std::size_t | vertIndex
| ) |  |
| inline

Definition at line 46 of file extruded_triangular3d.hpp.

## ◆ Element() [2/2]

plask::ExtrudedTriangularMesh3D::Element::Element | ( | const ExtrudedTriangularMesh3D & | mesh,
|  | std::size_t | elementIndex
| ) |  |

Definition at line 35 of file extruded_triangular3d.cpp.

## Member Function Documentation

## ◆ contains()

bool plask::ExtrudedTriangularMesh3D::Element::contains | ( | Vec< 3, double > | p | ) | const

Check if point `p` is included in `this` element.

Parameters

  p | point to check

Returns
  `true` only if `p` is included in `this`

Definition at line 56 of file extruded_triangular3d.cpp.

## ◆ getArea()

double plask::ExtrudedTriangularMesh3D::Element::getArea | ( |  | ) | const
| inline

Get volume of the prism represented by this element.

Returns
  the volume of the element

Definition at line 110 of file extruded_triangular3d.hpp.

## ◆ getBaseArea()

double plask::ExtrudedTriangularMesh3D::Element::getBaseArea | ( |  | ) | const
| inline

Get area of the prism base (which is a triangle).

Returns
  the area of the prism base

Definition at line 97 of file extruded_triangular3d.hpp.

## ◆ getBottomNode()

Vec< 3, double > plask::ExtrudedTriangularMesh3D::Element::getBottomNode | ( | std::size_t | bottom_triangle_node_nr | ) | const
| inline

Get coordinates of the bottom base (triangle) vertex.

Parameters

  index | index of vertex in the triangle; equals to 0, 1 or 2

Returns
  coordinates of the bottom base vertex

Definition at line 77 of file extruded_triangular3d.hpp.

## ◆ getBottomNodeIndex()

std::size_t plask::ExtrudedTriangularMesh3D::Element::getBottomNodeIndex | ( | std::size_t | bottom_triangle_node_nr | ) | const
| inline

Get mesh index of vertex of the bottom triangle.

Parameters

  bottom_triangle_node_nr | index of vertex in the triangle; equals to 0, 1 or 2

Returns
  mesh index of vertex of the bottom triangle

Definition at line 59 of file extruded_triangular3d.hpp.

## ◆ getBoundingBox()

Box3D plask::ExtrudedTriangularMesh3D::Element::getBoundingBox | ( |  | ) | const

Calculate minimal box which contains this element.

Returns
  calculated box

Definition at line 61 of file extruded_triangular3d.cpp.

## ◆ getHeight()

double plask::ExtrudedTriangularMesh3D::Element::getHeight | ( |  | ) | const
| inline

Get height of the prism base.

Returns
  the height

Definition at line 103 of file extruded_triangular3d.hpp.

## ◆ getIndex()

std::size_t plask::ExtrudedTriangularMesh3D::Element::getIndex | ( |  | ) | const
| inline

Returns
  index of this element

Definition at line 52 of file extruded_triangular3d.hpp.

## ◆ getMidpoint()

Vec< 3, double > plask::ExtrudedTriangularMesh3D::Element::getMidpoint | ( |  | ) | const

Returns
  position of the middle of the element

Definition at line 49 of file extruded_triangular3d.cpp.

## ◆ getTopNode()

Vec< 3, double > plask::ExtrudedTriangularMesh3D::Element::getTopNode | ( | std::size_t | bottom_triangle_node_nr | ) | const
| inline

Get coordinates of the top base (triangle) vertex.

Parameters

  index | index of vertex in the triangle; equals to 0, 1 or 2

Returns
  coordinates of the top base vertex

Definition at line 86 of file extruded_triangular3d.hpp.

## ◆ getTopNodeIndex()

std::size_t plask::ExtrudedTriangularMesh3D::Element::getTopNodeIndex | ( | std::size_t | top_triangle_node_nr | ) | const
| inline

Get mesh index of vertex of the top triangle.

Parameters

  top_triangle_node_nr | index of vertex in the triangle; equals to 0, 1 or 2

Returns
  mesh index of vertex of the top triangle

Definition at line 68 of file extruded_triangular3d.hpp.

## ◆ getVolume()

double plask::ExtrudedTriangularMesh3D::Element::getVolume | ( |  | ) | const
| inline

Definition at line 111 of file extruded_triangular3d.hpp.

## Member Data Documentation

## ◆ longTranIndex

std::size_t plask::ExtrudedTriangularMesh3D::Element::longTranIndex

Definition at line 44 of file extruded_triangular3d.hpp.

## ◆ mesh

const ExtrudedTriangularMesh3D& plask::ExtrudedTriangularMesh3D::Element::mesh

Definition at line 43 of file extruded_triangular3d.hpp.

## ◆ vertIndex

std::size_t plask::ExtrudedTriangularMesh3D::Element::vertIndex

Definition at line 44 of file extruded_triangular3d.hpp.

The documentation for this struct was generated from the following files:

- plask/mesh/extruded_triangular3d.hpp
- plask/mesh/extruded_triangular3d.cpp